#pragma once

#include<stdint.h>
#include<stddef.h>

enum ResManType {
	RESMAN_MODEL, RESMAN_MATERIAL, RESMAN_TEXTURE, RESMAN_PHYSICS, RESMAN_BIN, RESMAN_STREAM, RESMAN_FONT, RESMAN_OTHER, RESMAN_MAX
};

struct ResManRes {
	enum ResManType type;
	char *name;
	void *thing;
	size_t refs;
	
	struct ResManRes *next;
};

struct ResManBin {
	size_t length;
	uint8_t data[];
};

typedef int(*ResManLoader)(void *ud, struct ResManRes*);
typedef void(*ResManUnloader)(void *ud, const char *name, void *data);

struct ResManHandler {
	ResManLoader loader;
	ResManUnloader unloader;
	void *ud;
};

#define RESMAN_BUCKETS 32
extern struct ResMan {
	struct ResManHandler handlers[RESMAN_MAX];
	struct ResManRes *buckets[RESMAN_BUCKETS];
} ResMan;

struct ResManRes *resman_reffull(enum ResManType, const char*);
void *resman_ref(enum ResManType, const char*);
void resman_unref(enum ResManType, const char*);
void resman_unref_ptr(enum ResManType, void*);

struct ResManRes resman_find(const char*);

struct ResManRes *resman_rev(void*);
